/*
 *  sample.dcom.Client.java
 *
 *  (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
 */
package sample.dcom;

import com.ms.com.Variant;
import com.ms.com.SafeArray;
import java.util.Vector;
import java.util.Date;
/**
 * Sample for demonstrating how to use the javareg and jactivex tools for 
 * creating and using a COM object Inproc. 
 */
public class Client implements IListener{ 
/**
 * Main method for starting the sample from the command line.
 */
	public static void main(String args[]){	
		new Client();
	}
/**
 * Creates an instance of the Hub2 COM object using the Hub COM object
 * wrapper that was created with jactivex (on the hub.tlb generated by
 * javareg.  The resulting COM object is cast to hub.Hub_Dispatch, and has its
 * addListener, sendMessage, sendObjects, and removeListener methods 
 * called.  The results from Client and the Hub COM object
 * are printed to System.out. 
 */
	public Client(){
		hub.Hub_Dispatch mess = new hub.Hub();//Creates an instance of the COM object
		String key = mess.addListener(this);
		mess.sendMessage("This is the first test message");
		Variant[] vars = new Variant[3];//Packages the Object array for sending to the COM 
										//object.
		vars[0]=new Variant(new Integer(99));
		Vector datum = new Vector();
		datum.addElement(new Date());
		datum.addElement(new Vector());
		vars[1]=new Variant(datum);
		vars[2]=new Variant(new StringBuffer("Howdy"));
		SafeArray safe = new SafeArray(Variant.VariantVariant,3);
		safe.setVariants(0,3,vars,0);
		Variant sender = new Variant(safe,false);
		mess.sendObjects(sender);
		mess.removeListener(key);
		System.out.println("Client - Done");
		}
/**
 * Called by the COM object Hub when it services the registered listeners
 * with a new message. The new message is printed to System.out.
 * 
 * @param String message - Message sent by the server.
 */
	public synchronized void processMessage(String message){
		System.out.println("Client - message received "+message);
	}
/**
 * This method will be called by the COM object as it distributes data
 * to the registered listeners.  It simply displays the length of the
 * received array, and the type object that each element is.
 * 
 * @param Object[] data - Array of objects broadcast by the server.
 */
	public synchronized void processObjects(Object[] data){
		System.out.println("Client - data received : Data Length ");
		for (int i=0;i<data.length;i++)
			System.out.println("Client: Element "+i+" is "+data[i].getClass().getName()+
							   " contents "+data[i]);
	}
}