/*
 *  sample.dcom.IListener.java
 *
 *  (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
 */
package sample.dcom;
/**
 * These methods will be used by the Hub COM object to write results back to
 * the client.  An interface is used rather than directly writting to Client, 
 * to avoid circular dependencies.
 */
public interface IListener { 
	/**
	 * Handles the messages sent by the COM server object.
	 * 
	 * @param String message - message sent by the server.
	 */
	 public void processMessage(String message);
	 /**
	  * Processes the Object array broadcast by the server.
	  * 
	  * @param Object[] - data from the COM server.
	  */
	 public void processObjects(Object[] data);
}
