/*
 * sample.server.ICustom.java
 * 
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
 */
package sample.server;

/**
 * This COM interface will be used to illustrate how COM objects can be passed
 * as parameters both by reference and by value.
 * 
 * @version 1.0
 * 
 * @com.interface(iid=4AC6D512-6941-11d2-B937-00C04F8C9491, thread=NO) 
 */
public interface ICustom extends com.ms.com.IUnknown{ 
    /**
     * IID for this interface
     */
    public static final com.ms.com._Guid IID_ICustom = 
               new com.ms.com._Guid("{4AC6D512-6941-11d2-B937-00C04F8C9491}");
/**
 * Method for illustrating how a COM object can be returned by Value.
 * 
 * @return com.ms.com.IUnknown - Object that will be returned by Value.
 * 
 * @com.method(vtoffset=0)
 * @com.parameters([iid=00000000-0000-0000-C000-000000000046,thread=NO,type=OBJECT] return) 
 */        
    public com.ms.com.IUnknown getParamByValue();
/**
 * Method that returns an object by Reference.
 * 
 * @return com.ms.com.IUnknown - some java implemented COM object that is returned by Reference.
 *  
 * @com.method(vtoffset=1)
 * @com.parameters([iid=00000000-0000-0000-C000-000000000046,thread=NO,type=OBJECT] return) 
 */
    public com.ms.com.IUnknown getParamByRef();
 }