/*
 * sample.server.JCServer.java
 * 
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
 */
package sample.server;

/**
 * Simple Java COM object server that creates a classfactory for the java COM
 * Object that will be marshaled in this sample.
 * 
 * @version 1.0
 */
public class JCServer { 
    /**
     * This is the GUID used for the served Object
     */
    public static final com.ms.com._Guid IID_SERVEDOBJECT = 
              new com.ms.com._Guid("{D04B9181-6919-11d2-B936-00C04F8C9491}");
/**
 * Creates a new instance of the COM server, specifying the GUID and Java class
 * that will be served.
 */    
    public static void main(String[] args) { 
        System.out.println("About to startup");
        Thread t = new sample.dcom.COMServer(java.util.Vector.class,
                                             IID_SERVEDOBJECT,
                                             false,
                                             false,
                                             true, // don't shutdown
                                             true);// by value
        com.ms.com.ComLib.startMTAThread(t);  
        System.out.println("Starting second object server");
        Thread t2 = new sample.dcom.COMServer(JavaCOM.class,
                                             JavaCOM.GUID_JavaCOM,
                                             false,
                                             false,
                                             true, // don't shutdown
                                             false);// by ref
        com.ms.com.ComLib.startMTAThread(t2);     
        System.out.println("Done startup");
	}
}
