/*
 * sample.server.JavaCOM.java
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
 */
package sample.server;

/**
 * This COM object will be used to demonstrate passing parameters to COM methods
 * by value and by reference through using the sample.marshal.MarshalLib class.
 * 
 * @version 1.0
 */
public class JavaCOM implements ICustom{ 
        /**
         * GUID for this COM object
         */
        public static final com.ms.com._Guid GUID_JavaCOM = 
               new com.ms.com._Guid("{4AC6D514-6941-11d2-B937-00C04F8C9491}");
/**
 * This method will return an instance of the simple COMParam COM object to the
 * caller.
 * 
 * @return sample.server.COMParam - new instance of the COM object, returned byval.
 */        
    public com.ms.com.IUnknown getParamByValue(){
        System.out.println("COMParam method getParam called");
        return sample.marshal.MarshalLib.marshalByValue(new COMParam());   
    }
/**
 * Retrieves an instance of the COMParam object by reference, so the outof process 
 * client should expect to recieve the default COM proxy for this object.
 * 
 * @return sample.server.COMParam - object returned by reference.
 */    
    public com.ms.com.IUnknown getParamByRef(){
        System.out.println("Get param by ref called");
        return new COMParam();   
    }    
 }