# ----------------------------------------------------------------------------
# Standard Microsoft SDK for Java MAKEFILE for IPings
# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
# Tools and switches
# ----------------------------------------------------------------------------

CPP=cl.exe
CPP_SWITCHS=/c /DWIN32 /DREGISTER_PROXY_DLL /Fo"$(OUTDIR)\\" /Fd"$(OUTDIR)\\"
CPP_SWITCHS_EXT=$(CPP_SWITCHS) /D_WIN32_WINNT=0X400

# ----------------------------------------------------------------------------
# Set destination directory.
# ----------------------------------------------------------------------------

OUTDIR=.\Debug

# ----------------------------------------------------------------------------
# Set Obj and Lib files.
# ----------------------------------------------------------------------------

PROXYSTUBOBJS = $(OUTDIR)\dlldata.obj $(OUTDIR)\IPing_p.obj $(OUTDIR)\IPing_i.obj
PROXYSTUBLIBS = kernel32.lib oleaut32.lib rpcndr.lib rpcns4.lib rpcrt4.lib uuid.lib

# ----------------------------------------------------------------------------
# Build the sample.
# ----------------------------------------------------------------------------

all: $(OUTDIR) $(OUTDIR)\proxystub.dll

$(OUTDIR)\dlldata.obj : dlldata.c
	$(CPP) $(CPP_SWITCHS) dlldata.c
$(OUTDIR)\IPing_p.obj : IPing_p.c
	$(CPP) $(CPP_SWITCHS_EXT) IPing_p.c
$(OUTDIR)\IPing_i.obj : IPing_i.c
	$(CPP) $(CPP_SWITCHS) IPing_i.c

$(OUTDIR)\proxystub.dll : $(PROXYSTUBOBJS) proxystub.def
	link /dll /out:$(OUTDIR)\proxystub.dll /def:proxystub.def \
	$(PROXYSTUBOBJS) $(PROXYSTUBLIBS)

"$(OUTDIR)" :
	if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"