// TestService.java
//
// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
//
package sample.server;

import java.io.*;
import sample.dcom.*;
import com.ms.service.*;

public class TestService extends Service{
        /**
         * This is the classfactory that hosts the COM Singleton object
         */
        private COMServer object = null;
        /**
         * CLSID that we will be registering our classfactory with.
         */
        private com.ms.com._Guid clsid = Pinger.CLSID_Pinger;
/**
 * 
 */
    static
    {
        // Uncomment to disable the assassin.  The service will fail to respond 
        // in the time specified in the last waithint for the third pause
        // event received.  If the assassin is enabled (i.e. this line is commented
        // out, the default), then the service will be forcibly killed.
        
        //Service.disableassassin = true;
    }
    int intcount;
/**
 * This method starts the actual COM Server that will be running as our
 * NT Service.  It simply creates an instance of COMServer, specifying
 * sample.server.Pinger.class as the COM OBject, our clsid as its CLSID, 
 * and that it should be a singleton in an STA.
 * 
 * @param int dwArgc - This is the number of command line arguments that the
 *          NT Service has, which were specified when this service was started.
 * 
 * @param int spszArgv - This is the C form of the actual command line 
 *          parameters.
 */
    public TestService(String[] spszArgv){
        CheckPoint(1000);
        setRunning(ACCEPT_SHUTDOWN | ACCEPT_PAUSE_CONTINUE | ACCEPT_STOP);
            object = new COMServer(Pinger.class,clsid,true,false,true);
            System.out.println("About to start service!");
            com.ms.com.ComLib.startMTAThread(object);
            System.out.println("Service Started!");
    }
/**
 * Shuts down our COMServer, by calling its shutdown method, and stopping it
 * (as it is a Thread).  An entry to the eventlog is written specifying that a 
 * shutdown is about to occur, and when it has completed.
 */
    protected boolean handleStop(){
        setStopping(5000);
        System.out.println("Stopping the COM Server");
            object.shutdown();// Perform any COM cleanup required
            object.stop();
            System.out.println("Stop completed successfully.");
            return true;
    }
/**
 * This performs the 'Pause' operation by calling suspend on our COMServer.
 */
    protected boolean handlePause(){
        if (object!=null)
            object.suspend();
        return false;
    }
/**
 * This performs the 'Continue' operation by calling resume on our COMServer.
 */
    protected boolean handleContinue(){
        if (object!=null)
            object.resume();
        return false;
    }

    protected
    boolean handleShutdown ()
    {
        System.out.println("received shutdown, treating as stop");
        return handleStop();
    }
/*
    protected
    boolean handleInterrogate ()
    {
        System.out.println("received interrogate");
        setServiceStatus(getServiceStatus());
        System.out.println("sent status for interrogate");
        
        intcount++;
        if (intcount == 3)
        {
            System.out.println("received 3rd interrogate, stopping self in 5 seconds");
            try
            {
                Thread.sleep(5000);
            }
            catch (InterruptedException iex)
            {
                System.out.println("interrupted");
            }
            System.out.println("stopping");
            setStopped();
        }
        
        return false;
    }
*/
    }

