//
//  SampleObject.java
//
//  Copyright (c) 1999, Microsoft Corporation.  All rights reserved.
//
//  This source file demonstrates an implementation of an interface that has
//  iid_is and size_is attributes.
//

import com.ms.com.*;

public class SampleObject implements sample.ISampleInterface
{
    //  The virtual machine will automatically cast the returned object to the
    //  requested interface type.  If the object does not support the interface
    //  type, then E_FAIL will be returned.  An implementation could call
    //  com/ms/com/ComLib.supportsInterface to check if the object won't
    //  support the interface type in order to return an alternate error.
    public IUnknown BindToObject(_Guid riid) {
        return new SampleObject();
    }

    //  The virtual machine will automatically marshal "length" elements of the
    //  supplied array object.  If the size_is attribute was not specified, then
    //  this would have been a one element array.
    public void FlipIntArray(int length, int[] parray) {
        for (int index = 0; index < parray.length; index++) {
            parray[index] = -parray[index];
        }
    }

    //  The array with the size_is behavior can be primitive values or more
    //  complex types like String's or pointers to structures.
    public void FillBSTRArray(int length, java.lang.String[] parray) {
        for (int index = 0; index < parray.length; index++) {
            parray[index] = Integer.toString(index);
        }
    }
}
