/*++

Copyright (c) 1999  Microsoft Corporation

Module Name:

    jpsplit.h

Abstract:

    sample code.
    defines secondary methods and structures for splitting/parsing jexegen
     images.

--*/

#ifndef __JPSPLIT_H
#define __JPSPLIT_H


DECLARE_HANDLE( HCRIDATA );

// enumeration will be terminated if callback returns FALSE.
typedef
BOOL
(CALLBACK *CRI_ENTRY_ENUM_PROC)(
    DWORD   iCRIEntry,          // CRI entry index
    LPCWSTR pcwszClassName,
    LPCWSTR pcwszProgID,        // may be NULL
    LPCWSTR pcwszDescription,   // may be NULL
    DWORD   dwFlags,
    REFGUID rguidCLSID,
    REFGUID rguidTypelib,       // may be GUID_NULL, meaning no type library
    WORD    wVerMajor,          // typelib major version
    WORD    wVerMinor,          // typelib minor version
    void    *pvExtra );         // extra data supplied to CRIEnumEntries

HCRIDATA
CRIOpenData(
    HMODULE hModule,
    WORD    wCRIResourceID );

void
CRICloseData(
    HCRIDATA hCRIData );

ULONG
CRIGetEntryCount(
    HCRIDATA hCRIData );

BOOL
CRIEnumEntries(
    HCRIDATA            hCRIData,
    CRI_ENTRY_ENUM_PROC pfcnCallback,
    void                *pvExtra );


#endif