/*++

(C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

Module Name:

    cresprop.hpp

Abstract:

    Contains the CEnumResourceJAVAPROPERTY class definition.

--*/

#ifndef __CRESPROP_HPP__
#define __CRESPROP_HPP__

#include "javaexec.h"

typedef struct {
    LPOLESTR pszKey;
    UINT ValueID;
}   RESOURCEJAVAPROPERTY, * LPRESOURCEJAVAPROPERTY;

class CEnumResourceJAVAPROPERTY : public IEnumJAVAPROPERTY
{
private:
    ULONG m_cRef;

    LPRESOURCEJAVAPROPERTY m_pProperties;
    ULONG m_cProperties;
    ULONG m_current;

public:
    CEnumResourceJAVAPROPERTY(LPRESOURCEJAVAPROPERTY pProperties, ULONG
        cProperties);

    //  IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, LPVOID *ppvObj);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)();

    //  IEnumJAVAPROPERTY methods
    STDMETHOD(Next)(ULONG celt, LPJAVAPROPERTY rgelt, ULONG *pceltFetched);
    STDMETHOD(Skip)(ULONG celt);
    STDMETHOD(Reset)();
    STDMETHOD(Clone)(LPENUMJAVAPROPERTY *ppenum);
};

#endif  /* ! __CRESPROP_HPP__ */
