// PCH.HPP
//
// Created 08/01/99
//
// (C)Copyright 1999 Microsoft Corporation, All rights reserved.
//

#define INC_OLE2                /* for windows.h */
#define CONST_VTABLE            /* for objbase.h */
#define WIN32_LEAN_AND_MEAN     /* for windows.h */
#define _WIN32_WINNT 0x0403     /* for winbase.h */

#pragma warning(disable:4201) // nameless struct/union
#pragma warning(disable:4514) // unreferenced inline function has been removed

#include <windows.h>
#define _OLEAUT32_              /* hack DECLSPEC_IMPORT for olectl.h */
#include <olectl.h>
#include <commctrl.h>
#include <shellapi.h>

#include <limits.h>
#include <stddef.h>
#include <stdarg.h>

#include <stdio.h>
#include <malloc.h>

#include <javadbg.h>
#include <jevmon.h>

#include <assert.h>
#define ASSERT assert

#ifndef NDEBUG
#define EVAL(cond) ((cond) || (assert(!#cond), 0))
#else
#define EVAL(cond) (cond)
#endif

inline
void *operator new (size_t cb)
{
    return LocalAlloc(LMEM_FIXED, cb);
}

inline
void operator delete (void *p)
{
    LocalFree(p);
}

#define new(X) (new X)

#define ARRAY_ELEMENTS(rg) (sizeof(rg)/sizeof((rg)[0]))

#define TRASH(x) FillMemory(&(x), sizeof(x), 0xcc)

typedef const void *PCVOID;

#define INVALID_THREAD_ID (0xffffffff)

#pragma warning(disable:4100) // unreferenced formal parameter
#pragma warning(disable:4201) // nameless struct/union
#pragma warning(disable:4514) // unreferenced inline function has been removed

