// gcview.hpp
//
// Created 10/08/98
//
// (C)Copyright 1998-1999 Microsoft Corporation, All rights reserved.
//

#ifndef __GCVIEW_HPP__
#define __GCVIEW_HPP__

#include "baseview.hpp"
#include "gcinfo.hpp"


#define WC_HEAPMONITOR_GCHISTORYVIEWER "JavaHeapMonitor_GCHistoryViewerClass"

enum GCHistoryViewerColumns {
    GHV_COL_NUM,
    GHV_COL_OBJECTS,
    GHV_COL_SIZE,
    GHV_COL_MULTIREFOBJECTS,
    GHV_COL_OBJECTEDGES,
    GHV_COL_ROOTS,
    GHV_COL_ROOTEDGES,
    GHV_COL_MONITORS,
    GHV_NUM_COLUMNS,
};


class GCHistoryViewer : public BasicClient
{
private:

    static BOOL s_fRegisteredClass;

    HWND m_list;

    UINT m_iLastGCAdded;


    //------------------------------------------------------------------------
    // UI stuff

    static LRESULT CALLBACK WndProc (HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);

    BOOL OnCreateWindow ();

    VOID RedrawList ()
    {
        InvalidateRect(m_list, NULL, TRUE);
        UpdateWindow(m_list);
    }


    //------------------------------------------------------------------------
    
    // IHeapMonitorClient methods

    STDMETHODIMP OnStoppedExecution ()
    {
        return S_OK;
    }
    
    STDMETHODIMP OnResumeExecution ()
    {
        return S_OK;
    }

    STDMETHODIMP OnThreadCreated (THREADID thread)
    {
        return E_UNEXPECTED;
    }
    
    STDMETHODIMP OnDestroyThread (THREADID thread)
    {
        return E_UNEXPECTED;
    }

    STDMETHODIMP OnPackageCreated (PKGID pkg)
    {
        return E_UNEXPECTED;
    }

    STDMETHODIMP OnClassLoaded (CLASSID cls)
    {
        return E_UNEXPECTED;
    }
    
    STDMETHODIMP OnUnloadClass (CLASSID cls)
    {
        return E_UNEXPECTED;
    }

    STDMETHODIMP RootReferences (RootReferencesEventInfo *pinfo)
    {
        return E_UNEXPECTED;
    }

    STDMETHODIMP OnObjectStatusChange (OBJID id)
    {
        return E_UNEXPECTED;
    }

    STDMETHODIMP RootDiscoveryComplete ()
    {
        return S_OK;
    }

    STDMETHODIMP ObjectDiscoveryComplete ();
    

    //------------------------------------------------------------------------

public:

    BOOL Initialize (HeapMonitorManager *mgr);
};


#endif /* __GCVIEW_HPP__ */

