// instview.hpp
//
// Created 01/14/99
//
// (C)Copyright 1999 Microsoft Corporation, All rights reserved.
//

#ifndef __INSTVIEW_HPP__
#define __INSTVIEW_HPP__

#include "objview.hpp"


#define WC_HEAPMONITOR_CLSINSTVIEWER "JavaHeapMonitor_ClassInstancesViewerClass"


class ClassInstancesViewer : public ObjectViewer
{
private:

    HTREEITEM m_htiroot;


    //------------------------------------------------------------------------
    // UI stuff
    
    LRESULT CALLBACK WndProc (HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);

    BOOL GetItemText (HTREEITEM hti, PSTR &psztext, int &cchmaxtext);


    //------------------------------------------------------------------------
    
    // IHeapMonitorClient methods

    STDMETHODIMP OnStoppedExecution ()
    {
        return E_UNEXPECTED;
    }
    
    STDMETHODIMP OnResumeExecution ()
    {
        SendMessage(m_hwnd, WM_CLOSE, 0, 0);
        return S_OK;
    }


    //------------------------------------------------------------------------

    static int PopulateInstancesCB (ID id, ObjectID vmid, PVOID token);
    
public:

    BOOL Initialize (HeapMonitorManager *mgr, CLASSID cls);
};


#endif /* __INSTVIEW_HPP__ */

