// objlist.hpp
//
// Created 01/11/99
//
// (C)Copyright 1999 Microsoft Corporation, All rights reserved.
//

#ifndef __OBJLIST_HPP__
#define __OBJLIST_HPP__

#include "objview.hpp"


enum ObjectListViewerEvents
{
    WM_OLVEVENT_OBJ_STATUS_CHANGE = WM_OVEVENT_LAST,
};


class ObjectListViewer : public ObjectViewer
{
    DWORD m_oidflagsmask;


    //------------------------------------------------------------------------
    // UI manipulation

    LRESULT CALLBACK WndProc (HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);

    static int PopulateTreeCB (OBJID id, PVOID token);

    virtual BOOL ShouldDeleteTransientObject (HTREEITEM hti, OBJID obj);


    //------------------------------------------------------------------------

    // IHeapMonitorClient methods

    STDMETHODIMP OnObjectStatusChange (OBJID id)
    {
        SendMessage(m_hwnd, WM_OLVEVENT_OBJ_STATUS_CHANGE, 0, (LPARAM)id);
        return ObjectViewer::OnObjectStatusChange(id);
    }
    

    //------------------------------------------------------------------------
    
public:

    BOOL Initialize (HeapMonitorManager *mgr, PCSTR title, DWORD oidflagsmask);
};


#endif /* __OBJLIST_HPP__ */

