// refsview.hpp
//
// Created 10/08/98
//
// (C)Copyright 1998-1999 Microsoft Corporation, All rights reserved.
//

#ifndef __REFSVIEW_HPP__
#define __REFSVIEW_HPP__

#include "objview.hpp"


#define WC_HEAPMONITOR_OBJREFSVIEWER "JavaHeapMonitor_ObjectReferencesViewerClass"


class ObjectReferencesViewer : public ObjectViewer
{
private:

    HTREEITEM m_htiroot;


    //------------------------------------------------------------------------
    // UI stuff
    
    LRESULT CALLBACK WndProc (HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);

    BOOL GetItemText (HTREEITEM hti, PSTR &psztext, int &cchmaxtext);


    //------------------------------------------------------------------------
    
    // IHeapMonitorClient methods

    STDMETHODIMP OnStoppedExecution ()
    {
        return E_UNEXPECTED;
    }
    
    STDMETHODIMP OnResumeExecution ()
    {
        SendMessage(m_hwnd, WM_CLOSE, 0, 0);
        return S_OK;
    }


    //------------------------------------------------------------------------

    static int PopulateReferencesCB (ID id, ObjectID vmid, PVOID token);
    
public:

    BOOL Initialize (HeapMonitorManager *mgr, ObjectID vmid);
};


#endif /* __REFSVIEW_HPP__ */

