// calltrac.hpp
//
// Created 01/19/99
//
// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
//

#ifndef __CALLTRAC_HPP__
#define __CALLTRAC_HPP__

#include <jevmon.h>

class EventMonitor;
struct ThreadRecord;


class CallTracer
{
    EventMonitor *m_pmon;


    void PrintStackLeader (ThreadRecord *pThread);

    VOID SpewValue (CHAR chsig, PVOID pvalue);

    VOID SpewParams (ThreadRecord *pThread, MethodID method_id, StackID stack_id, ClassID idMethodClass, PCSTR pcszMethodName);

    VOID SpewReturnValue ();

public:

    HRESULT Initialize (EventMonitor *pmon);

    VOID Destruct ();


    VOID OnEnterMethod (ThreadRecord *pThread, MethodID method_id, StackID stack_id);

    VOID OnMethodExit (ThreadRecord *pThread, MethodID method_id, StackID stack_id);
};


class CallTracerThreadData
{
    friend class CallTracer;

    ULONG nStackFrames;
};


#endif /* __CALLTRAC_HPP__ */

