/*
 * project.hpp - Project C++ header file.
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 */


#ifndef __PROJECT_HPP__
#define __PROJECT_HPP__


/* System Headers
 *****************/

#define WIN32_LEAN_AND_MEAN     // for windows.h
#define INC_OLE2                // for windows.h
#define CONST_VTABLE            // for objbase.h

#pragma warning(disable:4514)   // "unreferenced inline function" warning

#pragma warning(disable:4201)   // "nameless struct/union" warning

#include <windows.h>

#pragma warning(default:4201)   // "nameless struct/union" warning

#include <limits.h>
#define DWORD_MAX ULONG_MAX

#define ARRAY_ELEMENTS(rg) (sizeof(rg)/sizeof((rg)[0]))

#define _QUOTE(s) #s
#define QUOTE(s) _QUOTE(s)


/* Constants
 ************/

/*
 * constants to be used with #pragma data_seg()
 *
 * These section names must be given the associated attributes in the project's
 * module definition file.
 */

#define DATA_SEG_READ_ONLY      ".rdata"
#define DATA_SEG_PER_INSTANCE   ".data"
#define DATA_SEG_SHARED         ".shared"


#endif  // ! __PROJECT_HPP__

