/*
 *
 * sample.decoder.ClasspathLoader.java
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
*/
package sample.decoder;
/**
 * Interface used to identify classes that can be used for loading java class 
 * bytecodes, given an arbitrary java class.  Objects which implement this interface
 * will likely have specialized skills for loading classes from arbitrary locations.
 *
 * @date	April 28,1998
 * @version	1.1
 */
public interface ClasspathLoader{
/**
 * Reads the specified class file from the classpath and returns the
 * bytes.  The Class name must be specified like this:
 * 
 *				java.lang.String = java/lang/String.class
 * 
 * @param String filename - Name of the class to load.
 * 
 * @return byte[] - bytes that represent this class, or null if couldn't be loaded.
 */
public byte[] getClassFromPath(String name);
}