/*
 *
 * sample.decoder.DecodeDisplayInterface.java
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
*/
package sample.decoder;
/**
 * This interface is used by the ClassViewer to ascertain which subobjects are contained
 * within a given structure to be displayed, as well as the display name for this object,
 * and the list of fields and their values for this object.  Implementation of this object
 * is purely for the ClassViewers benefit.
 *
 * @see sample.decoder.ClassViewer
 *
 * @date	April 28,1998
 * @version	1.1
*/
public interface DecodeDisplayInterface{
/**
 * This method is returns the display name for the object being represented.
 *
 * @returns String name representing this object and its attribute type.
*/
public String getName();
/**
 * This methods implementation ensures that any Vectors, or subobjects
 * which will need to be displayed as a subobject in a GUI can be fetched. The Hashtable 
 * is indexed by a String that is to be used as a display name, the contents
 * will be either a Vector of Strings/Objects or a Decode Object.
 *
 * 
 * @returns Hashtable of subobjects/structures to be displayed as seperate
 *				nodes in the GUI.
*/
public java.util.Hashtable getChildren();
/**
 * All raw information is stored inside sample.decoder.Entry objects, this method
 * will be used to retrieve them.
 * 
 * @return Vector - Vector containing all of the sample.decoder.Entry objects that
 *					have been defined for the implementing object.
 */
public java.util.Vector getEntries();
}

