/*
 *
 * sample.decoder.SecurityAPIAttribute.java
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
*/
package sample.decoder;

import java.util.Vector;
import java.util.Hashtable;
/**
 * The Security Space attribute marks a method so that tthe JIT compiler knows that any 
 * callers to this method require additional space in the stack frame.The extra frame 
 * space is used to storesecurity information at runtime.
 * 
 * SCOPE : Method
 *
 * @date	April 28,1998
 * @version	1.1
*/
public class SecurityAPIAttribute extends AttributeObject implements DecodeDisplayInterface,
		java.io.Serializable{
/**
 * This byte contains the data portion of this attribute
 */
	protected byte data=0;
/**
 * This method is a member of the DecodeDisplayInterface and is used to 
 * return the object name and the attribute name.  Subclasses of this object
 * should over ride this method to provide more detailed information.
 *
 * @see sample.decoder.DecodeDisplayInterface
 *
 * @returns String name representing this object and its attribute type.
*/
public String getName(){
	return "Security API";
}
/**
 * This is the workhorse for the object, it decodes an instance of itself starting at the
 * specified byte index into the stream provided.  This was created as a static method
 * rather than a constructor, as there may be times when this method returns a more
 * specialized object which is a subclass of itself.
 *
 * @param byte[] stream -  entire bytes of the class that is being decoded
 * @param int index - this is the index into the stream for the starting byte.
 * @param Vector constantPool - these are the constantPool objects, any index into the
 *								constant pool will be resolved by retrieving the object 
 *								at the required instance from this Vector.
 *
 * @returns Object - This is the decoded object which is a populated instance of this 
 *					class.
*/
public static Object getInstance(byte[] stream, int index,Vector constantPool){
        SecurityAPIAttribute xconst = new SecurityAPIAttribute();
        xconst.data=stream[index++];
		xconst.addEntry("Data",index-2,1,""+Decode.getIntegerValue(xconst.data),
						new byte[]{xconst.data});
		return xconst;
}
}