/*
 *
 * sample.viewer.IFindListener.java
 *
 * (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.
 *
*/
package sample.viewer;
/**
 * This interface will be used by any application that needs to receive feedback from
 * a Find dialog.  The users changes will be fed to the application through the
 * methods contained in this interface.
 * 
 * @version 1.0a
 */
public interface IFindListener{ 
/**
 * When the find next action is requested in the dialog, this method will be called.
 */
	public void processFindNext();
/**
 * Once the dialog has been canceled, or the user has pressed the cancel button, this
 * method will be called.
 */	
	public void processFindCancel();
/**
 * This method will be called when the user has finished indicating the test to be
 * used in the Find operation
 * 
 * @param String text - text to be used in the search.
 */	
	public void processFindText(String text);
/**
 * Toggles the users preference for ensuring that the search be case sensitive.
 * 
 * @param boolean b - toggles case sensitivity in the search (true=case sensitive) 
 */
	public void processFindCase(boolean b);
/**
 * Toggles the users preference for finding only full word matches to the selected
 * text.
 * 
 * @param boolean b - users preference to whole word matches (true=match whole word)
 */
	public void processFindWhole(boolean b);
}