package SimpComp ;
import com.ms.wfc.core.*;

/**
 * DrawingMode
 * 
 * The control can be drawn in various ways. This enumeration lets you 
 * control the way in which it is drawn 
 */
public class DrawingMode extends Enum {
    
    /**
     * Indicates that the control should be drawn normally - the default
     */
    public static final int         CALM              = 0 ;

    /**
     * Indicates that the control should be drawn by reversing the background 
     * and foreground colors
     */
    public static final int         AWKWARD             = 1 ;

    /**
     * Indicates that the control should be drawn with a red background 
     */
    public static final int         ANGRY                = 2 ;


    /**
     * Answer true if the given value is valid within this enumeration.
     * 
     * @param value   the enumeration value to check
     * 
     * @return  <b>boolean</b> true if the value is a member of this enum
     */
    public static boolean valid(int value) {
        return (value >= 0 && value <= 2);
    }        
}
